void sccp_dev_build_buttontemplate(sccp_device_t *d, btnlist * btn);
sccp_moo_t * sccp_build_packet(sccp_message_t t, size_t pkt_len);
int  sccp_dev_send(sccp_device_t * d, sccp_moo_t * r);
int  sccp_session_send(sccp_session_t * s, sccp_moo_t * r);
void sccp_dev_sendmsg(sccp_device_t * d, sccp_message_t t);
void sccp_session_sendmsg(sccp_session_t * s, sccp_message_t t);

void sccp_dev_set_keyset(sccp_device_t * d, uint8_t line, uint32_t callid, uint8_t opt);
void sccp_dev_set_ringer(sccp_device_t * d, uint8_t opt);
void sccp_dev_cleardisplay(sccp_device_t * d);
void sccp_dev_set_registered(sccp_device_t * d, uint8_t opt);

void sccp_dev_set_speaker(sccp_device_t * d, uint8_t opt);
void sccp_dev_set_microphone(sccp_device_t * d, uint8_t opt);
void sccp_dev_set_mwi(sccp_device_t * d, uint8_t line, uint8_t hasMail);
void sccp_dev_set_cplane(sccp_line_t * l, int status);
void sccp_dev_set_deactivate_cplane(sccp_channel_t * c);
void sccp_dev_starttone(sccp_device_t * d, uint8_t tone);
void sccp_dev_stoptone(sccp_device_t * d);
void sccp_dev_clearprompt(sccp_device_t * d, sccp_channel_t * c);
void sccp_dev_displayprompt(sccp_device_t * d, sccp_channel_t * c, char * msg, int timeout);

sccp_speed_t * sccp_dev_speed_find_byindex(sccp_device_t * d, int ind);
sccp_line_t * sccp_dev_get_activeline(sccp_device_t * d);
void sccp_dev_set_activeline(sccp_line_t * l);
void sccp_dev_check_mwi(sccp_device_t * d);
void sccp_dev_check_displayprompt(sccp_device_t * d);
void sccp_dev_select_line(sccp_device_t * d, sccp_line_t * l);
void sccp_dev_set_lamp(sccp_device_t * d, uint8_t instance, uint8_t lampMode);
void sccp_dev_speeddials_delete(sccp_device_t * d);

#define REQ(x,y) x = sccp_build_packet(y, sizeof(x->msg.y))
#define REQCMD(x,y) x = sccp_build_packet(y, 0)

